<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=11"/>
<meta name="generator" content="Doxygen 1.9.3"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>My Project: include/core/Application.hpp Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr id="projectrow">
  <td id="projectalign">
   <div id="projectname">My Project
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.9.3 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
var searchBox = new SearchBox("searchBox", "search",'Search','.html');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */
</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_d44c64559bbebec7f509842c48db8b23.html">include</a></li><li class="navelem"><a class="el" href="dir_3d69f64eaf81436fe2b22361382717e5.html">core</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle"><div class="title">Application.hpp</div></div>
</div><!--header-->
<div class="contents">
<a href="Application_8hpp.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a id="l00001" name="l00001"></a><span class="lineno">    1</span> </div>
<div class="line"><a id="l00012" name="l00012"></a><span class="lineno">   12</span><span class="preprocessor">#pragma once</span></div>
<div class="line"><a id="l00013" name="l00013"></a><span class="lineno">   13</span> </div>
<div class="line"><a id="l00014" name="l00014"></a><span class="lineno">   14</span><span class="preprocessor">#include &quot;../events/WindowEvent.hpp&quot;</span></div>
<div class="line"><a id="l00015" name="l00015"></a><span class="lineno">   15</span><span class="preprocessor">#include &quot;<a class="code" href="Event_8hpp.html">Event.hpp</a>&quot;</span></div>
<div class="line"><a id="l00016" name="l00016"></a><span class="lineno">   16</span><span class="preprocessor">#include &lt;SFML/Audio.hpp&gt;</span></div>
<div class="line"><a id="l00017" name="l00017"></a><span class="lineno">   17</span><span class="preprocessor">#include &lt;SFML/Graphics.hpp&gt;</span></div>
<div class="line"><a id="l00018" name="l00018"></a><span class="lineno">   18</span><span class="preprocessor">#include &lt;<a class="code" href="Gameplay_8hpp.html">gamestates/Gameplay.hpp</a>&gt;</span></div>
<div class="line"><a id="l00019" name="l00019"></a><span class="lineno">   19</span><span class="preprocessor">#include &lt;<a class="code" href="Scene_8hpp.html">gui/Scene.hpp</a>&gt;</span></div>
<div class="line"><a id="l00020" name="l00020"></a><span class="lineno">   20</span> </div>
<div class="line"><a id="l00021" name="l00021"></a><span class="lineno"><a class="line" href="namespacegg.html">   21</a></span><span class="keyword">namespace </span><a class="code hl_namespace" href="namespacegg.html">gg</a></div>
<div class="line"><a id="l00022" name="l00022"></a><span class="lineno">   22</span>{</div>
<div class="line"><a id="l00023" name="l00023"></a><span class="lineno">   23</span> </div>
<div class="line"><a id="l00024" name="l00024"></a><span class="lineno"><a class="line" href="classgg_1_1Application.html">   24</a></span><span class="keyword">class </span><a class="code hl_class" href="classgg_1_1Application.html">Application</a> : <span class="keyword">public</span> <a class="code hl_class" href="classgg_1_1IEventSubscriber.html">IEventSubscriber</a></div>
<div class="line"><a id="l00025" name="l00025"></a><span class="lineno">   25</span>{</div>
<div class="line"><a id="l00026" name="l00026"></a><span class="lineno">   26</span> </div>
<div class="line"><a id="l00027" name="l00027"></a><span class="lineno">   27</span>  <span class="keyword">private</span>:</div>
<div class="line"><a id="l00033" name="l00033"></a><span class="lineno">   33</span>    <span class="keywordtype">void</span> OnEvent(<a class="code hl_class" href="classgg_1_1IEvent.html">IEvent</a> *e) <span class="keyword">override</span>;</div>
<div class="line"><a id="l00034" name="l00034"></a><span class="lineno">   34</span>    <span class="keywordtype">void</span> OnWindowResizeEvent(<a class="code hl_class" href="classgg_1_1IEvent.html">IEvent</a> *);</div>
<div class="line"><a id="l00035" name="l00035"></a><span class="lineno">   35</span>    <span class="keywordtype">void</span> OnWindowCloseEvent(<a class="code hl_class" href="classgg_1_1IEvent.html">IEvent</a> *);</div>
<div class="line"><a id="l00036" name="l00036"></a><span class="lineno">   36</span>    <span class="keywordtype">void</span> OnKeyPressedEvent(<a class="code hl_class" href="classgg_1_1IEvent.html">IEvent</a> *);</div>
<div class="line"><a id="l00037" name="l00037"></a><span class="lineno">   37</span>    <span class="keywordtype">void</span> OnKeyReleasedEvent(<a class="code hl_class" href="classgg_1_1IEvent.html">IEvent</a> *);</div>
<div class="line"><a id="l00038" name="l00038"></a><span class="lineno">   38</span> </div>
<div class="line"><a id="l00039" name="l00039"></a><span class="lineno">   39</span>  <span class="keyword">public</span>:</div>
<div class="line"><a id="l00040" name="l00040"></a><span class="lineno"><a class="line" href="classgg_1_1Application.html#a8ec5c4ca52a13fa89a3d107fd2f8bde3">   40</a></span>    <a class="code hl_function" href="classgg_1_1Application.html#a8ec5c4ca52a13fa89a3d107fd2f8bde3">Application</a>();</div>
<div class="line"><a id="l00041" name="l00041"></a><span class="lineno"><a class="line" href="classgg_1_1Application.html#addc7756b106fcdddf588b7b358656054">   41</a></span>    <a class="code hl_function" href="classgg_1_1Application.html#addc7756b106fcdddf588b7b358656054">~Application</a>() <span class="keyword">override</span>;</div>
<div class="line"><a id="l00042" name="l00042"></a><span class="lineno">   42</span> </div>
<div class="line"><a id="l00043" name="l00043"></a><span class="lineno">   43</span>  <span class="keyword">public</span>:</div>
<div class="line"><a id="l00044" name="l00044"></a><span class="lineno"><a class="line" href="classgg_1_1Application.html#a703d54482a290b37d0be1cd76311c35a">   44</a></span>    <a class="code hl_function" href="classgg_1_1Application.html#a703d54482a290b37d0be1cd76311c35a">Application</a>(<a class="code hl_class" href="classgg_1_1Application.html">Application</a> &amp;) = <span class="keyword">delete</span>;</div>
<div class="line"><a id="l00045" name="l00045"></a><span class="lineno"><a class="line" href="classgg_1_1Application.html#a33bd0d684209797c83eea4980ab21ca7">   45</a></span>    <span class="keywordtype">void</span> <a class="code hl_function" href="classgg_1_1Application.html#a33bd0d684209797c83eea4980ab21ca7">operator=</a>(<span class="keyword">const</span> <a class="code hl_class" href="classgg_1_1Application.html">Application</a> &amp;) = <span class="keyword">delete</span>;</div>
<div class="line"><a id="l00046" name="l00046"></a><span class="lineno">   46</span> </div>
<div class="line"><a id="l00047" name="l00047"></a><span class="lineno">   47</span>  <span class="keyword">public</span>:</div>
<div class="line"><a id="l00048" name="l00048"></a><span class="lineno"><a class="line" href="classgg_1_1Application.html#a2db12436aa1eeac53715142fbc1e8390">   48</a></span>    <span class="keywordtype">void</span> <a class="code hl_function" href="classgg_1_1Application.html#a2db12436aa1eeac53715142fbc1e8390">Run</a>();</div>
<div class="line"><a id="l00054" name="l00054"></a><span class="lineno"><a class="line" href="classgg_1_1Application.html#a0442ba14bb784d3a6995bfb195745034">   54</a></span>    <span class="keyword">auto</span> <a class="code hl_function" href="classgg_1_1Application.html#a0442ba14bb784d3a6995bfb195745034">GetView</a>() -&gt; sf::View { <span class="keywordflow">return</span> mWindow-&gt;getView(); };</div>
<div class="line"><a id="l00055" name="l00055"></a><span class="lineno"><a class="line" href="classgg_1_1Application.html#a5d273cb1c4976d3f431a05c13dfa88ae">   55</a></span>    <span class="keyword">auto</span> <a class="code hl_function" href="classgg_1_1Application.html#a5d273cb1c4976d3f431a05c13dfa88ae">GetWindow</a>() -&gt; std::shared_ptr&lt;sf::RenderWindow&gt; { <span class="keywordflow">return</span> mWindow; }</div>
<div class="line"><a id="l00056" name="l00056"></a><span class="lineno">   56</span> </div>
<div class="line"><a id="l00057" name="l00057"></a><span class="lineno"><a class="line" href="classgg_1_1Application.html#afb47e39bb86f7667d6642874fd251ebf">   57</a></span>    <span class="keywordtype">void</span> <a class="code hl_function" href="classgg_1_1Application.html#afb47e39bb86f7667d6642874fd251ebf">ToggleFullscreen</a>(<span class="keywordtype">bool</span>);</div>
<div class="line"><a id="l00058" name="l00058"></a><span class="lineno"><a class="line" href="classgg_1_1Application.html#ae20d57caeee3df5081dad13b1554f0eb">   58</a></span>    <span class="keywordtype">void</span> <a class="code hl_function" href="classgg_1_1Application.html#ae20d57caeee3df5081dad13b1554f0eb">ToggleMusic</a>(<span class="keywordtype">bool</span>);</div>
<div class="line"><a id="l00059" name="l00059"></a><span class="lineno">   59</span> </div>
<div class="line"><a id="l00060" name="l00060"></a><span class="lineno"><a class="line" href="classgg_1_1Application.html#ae39054081b8d2975337d1ff454f0524c">   60</a></span>    <span class="keyword">static</span> <span class="keyword">auto</span> <a class="code hl_function" href="classgg_1_1Application.html#ae39054081b8d2975337d1ff454f0524c">GetInstance</a>() -&gt; <a class="code hl_class" href="classgg_1_1Application.html">Application</a> * { <span class="keywordflow">return</span> sInstance; }</div>
<div class="line"><a id="l00061" name="l00061"></a><span class="lineno">   61</span> </div>
<div class="line"><a id="l00062" name="l00062"></a><span class="lineno">   62</span>  <span class="keyword">private</span>:</div>
<div class="line"><a id="l00063" name="l00063"></a><span class="lineno">   63</span>    <span class="keyword">static</span> <a class="code hl_class" href="classgg_1_1Application.html">Application</a> *sInstance;</div>
<div class="line"><a id="l00064" name="l00064"></a><span class="lineno">   64</span>    std::shared_ptr&lt;sf::RenderWindow&gt; mWindow;</div>
<div class="line"><a id="l00065" name="l00065"></a><span class="lineno">   65</span>    std::shared_ptr&lt;sf::Music&gt; mMusic;</div>
<div class="line"><a id="l00066" name="l00066"></a><span class="lineno">   66</span>    <span class="keywordtype">bool</span> mRunning;</div>
<div class="line"><a id="l00067" name="l00067"></a><span class="lineno">   67</span>};</div>
<div class="line"><a id="l00068" name="l00068"></a><span class="lineno">   68</span> </div>
<div class="line"><a id="l00069" name="l00069"></a><span class="lineno">   69</span>}; <span class="comment">// namespace gg</span></div>
<div class="ttc" id="aEvent_8hpp_html"><div class="ttname"><a href="Event_8hpp.html">Event.hpp</a></div></div>
<div class="ttc" id="aGameplay_8hpp_html"><div class="ttname"><a href="Gameplay_8hpp.html">Gameplay.hpp</a></div></div>
<div class="ttc" id="aScene_8hpp_html"><div class="ttname"><a href="Scene_8hpp.html">Scene.hpp</a></div></div>
<div class="ttc" id="aclassgg_1_1Application_html"><div class="ttname"><a href="classgg_1_1Application.html">gg::Application</a></div><div class="ttdef"><b>Definition:</b> Application.hpp:25</div></div>
<div class="ttc" id="aclassgg_1_1Application_html_a0442ba14bb784d3a6995bfb195745034"><div class="ttname"><a href="classgg_1_1Application.html#a0442ba14bb784d3a6995bfb195745034">gg::Application::GetView</a></div><div class="ttdeci">auto GetView() -&gt; sf::View</div><div class="ttdoc">Get the View object.</div><div class="ttdef"><b>Definition:</b> Application.hpp:54</div></div>
<div class="ttc" id="aclassgg_1_1Application_html_a2db12436aa1eeac53715142fbc1e8390"><div class="ttname"><a href="classgg_1_1Application.html#a2db12436aa1eeac53715142fbc1e8390">gg::Application::Run</a></div><div class="ttdeci">void Run()</div></div>
<div class="ttc" id="aclassgg_1_1Application_html_a33bd0d684209797c83eea4980ab21ca7"><div class="ttname"><a href="classgg_1_1Application.html#a33bd0d684209797c83eea4980ab21ca7">gg::Application::operator=</a></div><div class="ttdeci">void operator=(const Application &amp;)=delete</div></div>
<div class="ttc" id="aclassgg_1_1Application_html_a5d273cb1c4976d3f431a05c13dfa88ae"><div class="ttname"><a href="classgg_1_1Application.html#a5d273cb1c4976d3f431a05c13dfa88ae">gg::Application::GetWindow</a></div><div class="ttdeci">auto GetWindow() -&gt; std::shared_ptr&lt; sf::RenderWindow &gt;</div><div class="ttdef"><b>Definition:</b> Application.hpp:55</div></div>
<div class="ttc" id="aclassgg_1_1Application_html_a703d54482a290b37d0be1cd76311c35a"><div class="ttname"><a href="classgg_1_1Application.html#a703d54482a290b37d0be1cd76311c35a">gg::Application::Application</a></div><div class="ttdeci">Application(Application &amp;)=delete</div></div>
<div class="ttc" id="aclassgg_1_1Application_html_a8ec5c4ca52a13fa89a3d107fd2f8bde3"><div class="ttname"><a href="classgg_1_1Application.html#a8ec5c4ca52a13fa89a3d107fd2f8bde3">gg::Application::Application</a></div><div class="ttdeci">Application()</div></div>
<div class="ttc" id="aclassgg_1_1Application_html_addc7756b106fcdddf588b7b358656054"><div class="ttname"><a href="classgg_1_1Application.html#addc7756b106fcdddf588b7b358656054">gg::Application::~Application</a></div><div class="ttdeci">~Application() override</div></div>
<div class="ttc" id="aclassgg_1_1Application_html_ae20d57caeee3df5081dad13b1554f0eb"><div class="ttname"><a href="classgg_1_1Application.html#ae20d57caeee3df5081dad13b1554f0eb">gg::Application::ToggleMusic</a></div><div class="ttdeci">void ToggleMusic(bool)</div></div>
<div class="ttc" id="aclassgg_1_1Application_html_ae39054081b8d2975337d1ff454f0524c"><div class="ttname"><a href="classgg_1_1Application.html#ae39054081b8d2975337d1ff454f0524c">gg::Application::GetInstance</a></div><div class="ttdeci">static auto GetInstance() -&gt; Application *</div><div class="ttdef"><b>Definition:</b> Application.hpp:60</div></div>
<div class="ttc" id="aclassgg_1_1Application_html_afb47e39bb86f7667d6642874fd251ebf"><div class="ttname"><a href="classgg_1_1Application.html#afb47e39bb86f7667d6642874fd251ebf">gg::Application::ToggleFullscreen</a></div><div class="ttdeci">void ToggleFullscreen(bool)</div></div>
<div class="ttc" id="aclassgg_1_1IEventSubscriber_html"><div class="ttname"><a href="classgg_1_1IEventSubscriber.html">gg::IEventSubscriber</a></div><div class="ttdef"><b>Definition:</b> Event.hpp:59</div></div>
<div class="ttc" id="aclassgg_1_1IEvent_html"><div class="ttname"><a href="classgg_1_1IEvent.html">gg::IEvent</a></div><div class="ttdef"><b>Definition:</b> Event.hpp:41</div></div>
<div class="ttc" id="anamespacegg_html"><div class="ttname"><a href="namespacegg.html">gg</a></div><div class="ttdef"><b>Definition:</b> Application.hpp:22</div></div>
</div><!-- fragment --></div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by&#160;<a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.3
</small></address>
</body>
</html>
